unit dukeset;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ShellApi, StdCtrls, Winsock, TSavedFormUnit, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    ListBox1: TListBox;
    Label3: TLabel;
    Edit2: TEdit;
    Button2: TButton;
    Memo1: TMemo;
    Edit3: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Edit4: TEdit;
    Memo2: TMemo;
    Button3: TButton;
    Button4: TButton;
    Label7: TLabel;
    Label6: TLabel;
    Edit5: TEdit;
    Button5: TButton;
    OpenDialog1: TOpenDialog;
    Memo3: TMemo;
    Button6: TButton;
    Button7: TButton;
    ListBox2: TListBox;
    Label8: TLabel;
    Button9: TButton;
    RadioGroup1: TRadioGroup;
    rbc: TRadioButton;
    rip: TRadioButton;
    Edit6: TEdit;
    Button8: TButton;
    Label9: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Label7MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Label7MouseLeave(Sender: TObject);
    procedure Label7Click(Sender: TObject);
    procedure rbcClick(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure ripClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Rivi: String;
  Map: String;
  Tiedosto: string;
  Hakemisto: string;
  his: string;
  tyyli: string;

implementation

{$R *.dfm}
function getIPs: Tstrings;
type
  TaPInAddr = array[0..10] of PInAddr;
  PaPInAddr = ^TaPInAddr;
var
  phe: PHostEnt;
  pptr: PaPInAddr;
  Buffer: array[0..63] of Char;
  I: Integer;
  GInitData: TWSAData;
begin
  WSAStartup($101, GInitData);
  Result := TstringList.Create;
  Result.Clear;
  GetHostName(Buffer, SizeOf(Buffer));
  phe := GetHostByName(buffer);
  if phe = nil then Exit;
  pPtr := PaPInAddr(phe^.h_addr_list);
  I    := 0;
  while pPtr^[I] <> nil do
  begin
    Result.Add(inet_ntoa(pptr^[I]^));
    Inc(I);
  end;
  WSACleanup;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
Tiedosto:='duke3d_w32.exe';
Hakemisto:='';
if FileExists('settings.txt')
then
begin
Memo3.Lines.LoadFromFile('settings.txt');
Edit5.Text:=Memo3.Lines[0];
Edit4.Text:=Memo3.Lines[1];
Edit3.Text:=Memo3.Lines[2];
Edit1.Text:=Memo3.Lines[3];
end;
if FileExists('ips.txt')
then
begin
Listbox1.Items.LoadFromFile('ips.txt');
end;
Memo1.Lines:=getIPs;
Edit3.Text:=Memo1.Lines[0];

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Edit1.Text:='1635';
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
Memo3.Lines.Clear;
Memo3.Lines.Add(Edit5.Text);
Memo3.Lines.Add(Edit4.Text);
Memo3.Lines.Add(Edit3.Text);
Memo3.Lines.Add(Edit1.Text);
Rivi:='/m /c1 /i1 -name ' + Edit4.text + ' -net net.txt';
Memo2.lines.Clear;
Memo2.Lines.Add('interface ' + Edit3.Text + ':' + Edit1.Text);
Memo2.Lines.Add('mode peer');
Memo2.Lines.Add(ListBox1.Items.GetText);
Memo2.Lines.SaveToFile(Hakemisto + 'net.txt');
Listbox1.Items.SaveToFile('ips.txt');
Memo3.lines.SaveToFile('settings.txt');

ShellExecute(Handle, 'open', PChar(Tiedosto), PChar(Rivi), nil, SW_SHOW);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
ListBox1.Items.Add('allow ' + Edit2.Text + ':' + Edit1.text);

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
ListBox1.Items.Delete(ListBox1.ItemIndex);

end;

procedure TForm1.Button5Click(Sender: TObject);
begin
OpenDIalog1.Execute;
Edit5.Text:=OpenDIalog1.FileName;
Tiedosto:=OpenDIalog1.FileName;
  Hakemisto:=OpenDIalog1.InitialDir;


end;

procedure TForm1.Button6Click(Sender: TObject);
begin
Memo3.Lines.Clear;
Memo3.Lines.Add(Edit5.Text);
Memo3.Lines.Add(Edit4.Text);
Memo3.Lines.Add(Edit3.Text);
Memo3.Lines.Add(Edit1.Text);
Listbox1.Items.SaveToFile('ips.txt');
Memo3.lines.SaveToFile('settings.txt');
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
Close;
end;

procedure TForm1.Label7MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
Label7.Color:=ClBlue;
Label7.Caption:='http://vatvit.homelinux.org';
end;

procedure TForm1.Label7MouseLeave(Sender: TObject);
begin
Label7.Color:=clBtnFace;
Label7.Caption:='VatVit 2005';
end;

procedure TForm1.Label7Click(Sender: TObject);
begin
 ShellExecute(Handle, 'open', 'http://vatvit.homelinux.org', nil, nil, SW_SHOW);
end;

procedure TForm1.rbcClick(Sender: TObject);
begin
tyyli:='bc';
Edit2.Visible:=False;
Edit6.Visible:=True;
Label3.Caption:='Number Of Players:';
Button2.Visible:=False;
ListBox1.Visible:=False;
Button8.Visible:=True;
Button3.Visible:=False;

end;

procedure TForm1.Button8Click(Sender: TObject);
begin

Memo3.Lines.Clear;
Memo3.Lines.Add(Edit5.Text);
Memo3.Lines.Add(Edit4.Text);
Memo3.Lines.Add(Edit3.Text);
Memo3.Lines.Add(Edit1.Text);
Rivi:='/m /c1 /i1 -name ' + Edit4.text + ' -net net.txt';
Memo2.lines.Clear;
Memo2.Lines.Add('interface ' + Edit3.Text + ':' + Edit1.Text);
Memo2.Lines.Add('mode peer');
Memo2.Lines.Add('broadcast ' + Edit6.Text);
Memo2.Lines.SaveToFile(Hakemisto + 'net.txt');
Listbox1.Items.SaveToFile('ips.txt');
Memo3.lines.SaveToFile('settings.txt');

ShellExecute(Handle, 'open', PChar(Tiedosto), PChar(Rivi), nil, SW_SHOW);
end;

procedure TForm1.ripClick(Sender: TObject);
begin
tyyli:='bc';
Edit2.Visible:=True;
Edit6.Visible:=False;
Label3.Caption:='Allowed IP List:';
Button2.Visible:=True;
ListBox1.Visible:=True;
Button8.Visible:=False;
Button3.Visible:=True;

end;

end.
